package WebFlow.TestEvent; 

import WebFlow.*; 
import WebFlow.event.*; 
import org.omg.CORBA.*; 
import java.io.*; 
import java.awt.*; 
import java.awt.event.*; 
import java.net.*; 
import java.applet.*; 
import javax.swing.*; 

public class Client
{
    //
    //  Standalone program initialization
    //
    
    public static void main(String args[]) 
    {
	configReader config ; 
	try {
	    ORB orb = ORB.init(args , new java.util.Properties()); 
	    
	    String masterURL = args[0] ; 
	    String ref = getIORFromURL(masterURL); 
	    org.omg.CORBA.Object obj = orb.string_to_object(ref); 
	    if( obj == null)
		throw new RuntimeException(); 
	    org.omg.CORBA.Object []ms = new org.omg.CORBA.Object[10]; 

	    WebFlowContext ws = WebFlowContextHelper.narrow(obj); 
	    ms[0] = ws ; 
	    if( ws == null)
		    throw new RuntimeException() ; 
	    System.out.println("Client: Created WFServerHelper"); 

	    org.omg.CORBA.Object   p1 , p2 , k1 , k2 ; 
	    //	    BeanContextChild bcc1 , bcc2 ; 
	    WebFlowContext c2 , ms_0 , ms_1, ms_2;

	    ms[1]= ms_0 = 
		WebFlowContextHelper.narrow(ws.getContext("TestEventServer"));
	    System.out.println("Client: got ms_0:"+ms_0);
		
	    ms[2]=ms_1 =
		WebFlowContextHelper.narrow(ws.getContext("TestEventServer/TestEvent_1"));
	    System.out.println("Client: got ms_1:"+ms_1);

	    ms[3]=ms_2= 
		WebFlowContextHelper.narrow(ws.getContext("TestEventServer/TestEvent_2"));
	    System.out.println("Client: got ms_2:"+ms_2);
		
	    ms[4]=p1= ms_1.addNewModule("Action");
	    System.out.println("Client: got Action Module");
		
	    ms[5]=k1 = ms_2.addNewModule("Response");
	    System.out.println("Client: got Response Module");

	    Action act = ActionHelper.narrow(p1); 
	    System.out.println(act.test()); 

	    Response res = ResponseHelper.narrow(k1); 	
	    System.out.println(res.test()); 

	    /*
	    bcc1  = BeanContextChildHelper.narrow(p1);
	    String id1 = bcc1.getObjectID(); 
	    System.out.println("Main p1 has ID: " + id1); 

	    bcc2 = BeanContextChildHelper.narrow(k1); 
	    String id2 = bcc2.getObjectID(); 
	    System.out.println("Change k1 has ID:" +id2); 
	    */

     /* Client register events to specify which module an event comes from,
	   which module and what method an event is received by */
	    
	    ws.attachPullEvent(p1 , "Fire_Show1" , ws ); 
	    System.out.println("Client: got ActionImpl Vision"); 

	    ws.attachPullEvent(k1 , "Fire_Show2" , ws ); 
	    System.out.println("Client: got ResponseImpl Vision"); 

	    ms_1.attachPushEvent(p1,"Fire_Button",k1,"getEvent");
	    ms_1.attachPushEvent(p1,"Reset_Button",k1,"getEvent");
	    ms_1.attachPushEvent(p1, "Quit_Button" , k1 , "getEvent"); 

	    act.runvision1(); 
	    System.out.println("vision1 succeed"); 
		
	    res.runvision2(); 
	    System.out.println("vision2 succeed"); 
				
	    String input , inputcommand;
	    
	    try{
		do {
		    System.out.print(">> ");
		    DataInputStream commandIn = new DataInputStream(System.in);
		    BufferedReader in =
			new BufferedReader(new InputStreamReader(commandIn));
		    inputcommand = in.readLine();

		    if(inputcommand.equals("Fire")){
			act.runfire(); }

		    if(inputcommand.equals("Reset")){
			act.runreset(); }

		    if(inputcommand.equals("Quit")) {
			act.runquit();
			System.out.println("master is killed !!");
			ms_0.removeMyself(); }

		}while(inputcommand != "Exit"); 
	    }catch(IOException ex) {
		System.out.println("IO_Error : "+ex); }
	    catch(COMM_FAILURE ex) {
		System.out.println("Command_Error: "+ex);
		System.err.println(ex.getMessage());
		ex.printStackTrace();
		System.exit(1); }
		
	    do {
		System.out.print("> ");
		DataInputStream dataIn = new DataInputStream(System.in);
		BufferedReader in =
		    new BufferedReader(new InputStreamReader(dataIn));
		input = in.readLine();
		
		if(input.indexOf("d") == 0){
		    int index = input.indexOf("-");
		    int m1 = Integer.parseInt(input.substring(1,index));
		    int m2 = Integer.parseInt(input.substring(index+1));
		    System.out.println("Client: Detaching property from :"+m1+"to:"+m2); 
		    System.out.println("Client: Detaching property p1-k1");
		    ms_2.detachPushEvent(ms[m1],"timeElapsed",ms[m2],"getTime");
		    System.out.println("Client: Detached property:"+
				       m1+"-"+m2);
		}
		if(input.indexOf("rc") == 0){
		    int index = input.indexOf("-");
		    int ci = Integer.parseInt(input.substring(2,index));
		    int mi = Integer.parseInt(input.substring(index+1));
		    System.out.println("Client: Remove context:"+mi); 
		    System.out.println(" from context:" +ci); 
		    WebFlowContext wfc = WebFlowContextHelper.narrow(ms[ci]);
		    wfc.removeContext(ms[mi]);
		}
			
		if(input.indexOf("rm") == 0){
		    int index = input.indexOf("-");
		    int ci = Integer.parseInt(input.substring(2,index));
		    int mi = Integer.parseInt(input.substring(index+1));
		    System.out.println("Client: Remove child:"+mi); 
		    System.out.println(" from context:" +ci); 
		    WebFlowContext wfc = WebFlowContextHelper.narrow(ms[ci]);
		    wfc.removeModule(ms[mi]);
		}
		if(input.indexOf("cm") == 0){
		    int index = input.indexOf("-");
		    int lindex = input.lastIndexOf("-");
		    int ci = Integer.parseInt(input.substring(2,index));
		    int mi = Integer.parseInt(input.substring(index+1,
							      lindex));
		    int mj = Integer.parseInt(input.substring(lindex+1));
		    
		    System.out.println("Client: Remove child:"+mi+" from context:"+ci);
		    WebFlowContext wfc = WebFlowContextHelper.narrow(ms[ci]);
		    wfc.copyModuleBinding(ms[mi], ms[mj]);
		}
		if(input.indexOf("ci") == 0){
		    int index = input.indexOf("-");
		    int ci = Integer.parseInt(input.substring(2,index));
		    String name = input.substring(index+1);
		    System.out.println("Client: Change Impl of :"+ci); 
		    System.out.println(" with :" +name); 
		    
		    BeanContextChild bcc = BeanContextChildHelper.narrow(ms[ci]);
		    bcc.changeImpl(name);
		}
		
	    }while(input.indexOf("x") != 0);
	}catch(IOException e){}
	catch(COMM_FAILURE ex) {
	    System.err.println(ex.getMessage());
	    ex.printStackTrace();
	    System.exit(1);
	}
    }

    public static String  getIORFromURL(String url) {
	System.out.println("Slave WebFlow is getting IOR from url:"+url);
	String masterServerIOR="";
	String thisLine=null;
	
	//Open the URL for reading
	
	try {
	    URL u = new URL(url);
	    
	    // now turn the URL into a DataInputStream
	    try {
		DataInputStream theHTML = new DataInputStream(u.openStream());
		while((thisLine = theHTML.readLine()) != null) {
		    masterServerIOR += thisLine;
		} // while loop ends here
	    }
	    catch (Exception e) {
		System.out.println("configReader:getIORfromURL:"+e);
	    }
        } // end try
        catch (Exception e) {
	    System.out.println("configReader:getIORfromURL:"+e);
        }
        return masterServerIOR ; 
    }
}
